package pro.skalski.zadanie1;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import java.util.ArrayList;

public class Database {
    private static final int VERSION = 1;
    private static final String FILE_NAME = "database.db";
    private static final String TABLE = "list";

    public static final String KEY_ID = "id";
    public static final String ID_OPTIONS = "INTEGER PRIMARY KEY AUTOINCREMENT";

    public static final String KEY_ITEM = "item";
    public static final String NAME_OPTIONS = "TEXT NOT NULL";

    private static final String DB_CREATE_TODO_TABLE =
            "CREATE TABLE " + TABLE + "( " +
                    KEY_ID + " " + ID_OPTIONS + ", " +
                    KEY_ITEM + " " + NAME_OPTIONS  +");";

    private SQLiteDatabase db;
    private Context context;
    private DatabaseHelper dbHelper;

    private static class DatabaseHelper extends SQLiteOpenHelper {
        public DatabaseHelper(Context context, String name,
                              SQLiteDatabase.CursorFactory factory, int version) {
            super(context, name, factory, version);
        }

        @Override
        public void onCreate(SQLiteDatabase db) {
            db.execSQL(DB_CREATE_TODO_TABLE);
        }

        @Override
        public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {}
    }
    public Database(Context context) {
        this.context = context;
    }

    public Database open(){
        dbHelper = new DatabaseHelper(context, FILE_NAME, null, VERSION);
        try {
            db = dbHelper.getWritableDatabase();
        } catch (SQLException e) {
            db = dbHelper.getReadableDatabase();
        }
        return this;
    }

    public void close() {
        dbHelper.close();
    }

    public ArrayList<String> getAllElements() {
        String[] columns = {KEY_ITEM};
        Cursor tmp = db.query(TABLE, columns, null, null, null, null, null);
        ArrayList<String> list = new ArrayList<String>();
        if(tmp.getCount() > 0){
            tmp.moveToFirst();
            do {
                String item = tmp.getString(tmp.getColumnIndex(KEY_ITEM));
                list.add(item);
            }
            while (tmp.moveToNext());
        }
        return list;
    }

    public long insertNewElement(String name) {
        ContentValues newElement = new ContentValues();
        newElement.put(KEY_ITEM, name);
        return db.insert(TABLE, null, newElement);
    }

    public boolean deleteElement(String name){
        String where = KEY_ITEM + "=" +"'"+ name+"'";
        return db.delete(TABLE, where, null) > 0;
    }
}
