package pro.skalski.zadanie1;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.CompoundButton;
import android.widget.Switch;

public class OptionsActivity extends AppCompatActivity implements CompoundButton.OnCheckedChangeListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.i("ZAD1S", "Options: onCreate");
        setContentView(R.layout.activity_options);
        setTitle("Options");
        Switch switchCanAdd = (Switch) findViewById(R.id.switch_can_add);
        Switch switchShowCredits = (Switch) findViewById(R.id.switch_show_credits);
        if (switchCanAdd != null) {
            switchCanAdd.setOnCheckedChangeListener(this);
        }
        if (switchShowCredits != null) {
            switchShowCredits.setOnCheckedChangeListener(this);
        }
    }

    protected void onResume() {
        super.onResume();
        Log.i("ZAD1S", "Options: onResume");

        Switch switchCanAdd = (Switch) findViewById(R.id.switch_can_add);
        switchCanAdd.setChecked(Settings.isCanAdd());

        Switch switchShowCredits = (Switch) findViewById(R.id.switch_show_credits);
        switchShowCredits.setChecked(Settings.isShowCredits());
    }

    public void onClickBack(View v) {
        Intent intent = new Intent(this, MainActivity.class);
        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(intent);
        finish();
    }

    @Override
    public void onCheckedChanged(CompoundButton compoundButton, boolean b) {
        if (compoundButton.getId() == R.id.switch_can_add) {
            Log.i("ZAD1", "Change: Switch Can Add, " + b);
            Settings.setCanAdd(b);
        } else  if (compoundButton.getId() == R.id.switch_show_credits) {
            Log.i("ZAD1", "Change: Switch Show Credits, " + b);
            Settings.setShowCredits(b);
        }
    }
}
