package pro.skalski.zadanie1;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.text.InputType;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Switch;
import android.widget.Toast;

import java.util.ArrayList;

public class ProductListActivity extends AppCompatActivity  {
    public static ArrayList<String> listElements = new ArrayList<String>();
    ArrayAdapter<String> adapter;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.i("ZAD1S", "List: onCreate");
        setContentView(R.layout.activity_list);
        setTitle("List");

        adapter = new ArrayAdapter<String>(this,
                android.R.layout.simple_list_item_1, android.R.id.text1, listElements);

        ListView listView = (ListView) findViewById(R.id.listview_list);
        listView.setAdapter(adapter);


        Database db = new Database(getApplicationContext());
        db.open();
        listElements.clear();
        for(String item : db.getAllElements()) {
            Log.i("ZAD1S", "List: load element: " + item);
            listElements.add(item);
        }
        db.close();
        adapter.notifyDataSetChanged();

        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int itemPosition, long id) {
                ListView listView = (ListView) findViewById(R.id.listview_list);
                final int itemPositionFinal = itemPosition;
                final String itemValue = (String) listView.getItemAtPosition(itemPosition);
                new AlertDialog.Builder(view.getContext()).setMessage("Do you want to remove: " + itemValue + "?")
                    .setTitle("Remove element")
                    .setNegativeButton("NO", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {}
                    })
                    .setPositiveButton("YES", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            Database db = new Database(getApplicationContext());
                            db.open();
                            db.deleteElement(itemValue);
                            db.close();


                            listElements.remove(itemPositionFinal);
                            adapter.notifyDataSetChanged();
                            Toast.makeText(getApplicationContext(),
                                "Removed: " + itemValue
                                , Toast.LENGTH_LONG
                            )
                            .show();
                        }
                    })
                    .show();
            }
        });
    }

    protected void onResume() {
        super.onResume();
        Log.i("ZAD1S", "List: onResume");
        Button button = (Button) findViewById(R.id.button_add);
        if (Settings.isCanAdd()) {
            button.setVisibility(View.VISIBLE);
        } else {
            button.setVisibility(View.INVISIBLE);
        }
    }

    public void onClickBackOnList(View v) {
        Intent intent = new Intent(this, MainActivity.class);
        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(intent);
        finish();
    }

    public void onClickAdd(View v) {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setTitle("New element");

        final EditText input = new EditText(this);
        input.setInputType(InputType.TYPE_CLASS_TEXT);
        builder.setView(input);

        builder.setPositiveButton("Add", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                String m_Text = input.getText().toString();


                Database db = new Database(getApplicationContext());
                db.open();
                db.insertNewElement(m_Text);
                db.close();

                listElements.add(m_Text);
                adapter.notifyDataSetChanged();
            }
        });
        builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.cancel();
            }
        });

        builder.show();
    }
}
